#!/usr/bin/env slsh

% Usage : monitor.sl path [event]
% This example monitor the given file or directory for selected event
% (default to IN_ACCESS)

require ("inotify");
require ("select");

variable fd, fds, wd, e, events = 0;

if (__argc > 2)
{
   foreach e (__argv [[2:]])
     events |= int (e);
}
else
  events = IN_ACCESS;

try (e)
  fd = inotify_init ();
catch InotifyError:
{
   message (e.descr);
}

wd = inotify_add_watch (fd, __argv [1], events);

forever
{   
   fds = select ([fd], [NULL], [NULL], -1);   
   do
     {	
	(,,, $0) = inotify_read_event (fd);
	vmessage ("File : %s", $0);
     }
   while (inotify_pending (fd));
}
